#include<36064s.h>
#include <string.h>
#include "vs-bb020.h"
#include <machine.h>
//֐

BYTE f_IREnable = 0;
int PS_Set_AN();
BYTE Ds2rw(const BYTE *cmd);
void Ds2Com(const BYTE * cmd,BYTE txLen);

const BYTE strHex[16]={"0123456789ABCDEF"};
void InitAD();

//MtrPWM ********************************************************************//
const UINT MTR_PWM_CYC = 0x2000;

void InitMtrPwm()
{	
	TZ.TSTR.BIT.STR0=0;
	TZ.TSTR.BIT.STR1=0;
	
	TZ0.TCR.BYTE =	0x20;	//GRAŃNAAGbWAӂŃJEg
	TZ1.TCR.BYTE =	0x20;	//GRAŃNAAGbWAӂŃJEg
	
	TZ.TPMR.BYTE =	0xFF;	//ʏ
	
	TZ.TOCR.BYTE =	0x00;	//TZ0F͂1o	,1:1o
		
	TZ0.POCR.BYTE = 0x00;
	TZ1.POCR.BYTE = 0x00;
	
	
	TZ0.GRA=MTR_PWM_CYC;
	TZ1.GRA=MTR_PWM_CYC;
	
	TZ.TOER.BYTE =	0x33;	//TZ0Fo͋
		
	TZ.TMDR.BYTE =	0x00;	//ʏ
	TZ.TFCR.BYTE =	0x00;	//ʏ
	
	TZ0.TSR.BYTE =	0x00;	//G[tONA
	TZ1.TSR.BYTE =	0x00;	//G[tONA

	TZ0.TCNT=0;
	TZ1.TCNT=0;

	TZ0.GRC = 0;
	TZ0.GRD = 0;
	TZ1.GRC = 0;
	TZ1.GRD = 0;
}

void Mtr_Run_BB(UINT mt1,UINT mt2)
{
	BYTE i;
	UDWORD tempSint,tempSint2;
	UINT duty[4];

		//f[eB̃Zbg
		for(i=0;i<2;i++){
			UINT MTRtemp;
			if(i == 0)
				MTRtemp = mt1; 
			else
				MTRtemp = mt2; 
				
			if(MTRtemp == 0 || MTRtemp == 0x8000){
				tempSint=0;
				tempSint2=0;
			}
			else if(MTRtemp < 0x8000){
				tempSint = MTRtemp;
				tempSint2 = 0;
			}
			else if(MTRtemp > 0x8000){
				tempSint = 0;
				tempSint2 = (UDWORD)(0x10000 - MTRtemp);
			}			
			duty[i*2]=(UINT)((tempSint*(UDWORD)MTR_PWM_CYC)/0x8000);
			duty[i*2+1]=(UINT)((tempSint2*(UDWORD)MTR_PWM_CYC)/0x8000);
		}
		
		TZ0.GRC=duty[2];
		TZ0.GRD=duty[3];
		TZ1.GRC=duty[0];
		TZ1.GRD=duty[1];		
		
		//TZ~܂ĂX^[g
		if(TZ.TSTR.BIT.STR0!=1){
			TZ.TSTR.BIT.STR0=1;		//JEgX^[g
		}
		if(TZ.TSTR.BIT.STR1!=1){
			TZ.TSTR.BIT.STR1=1;		//JEgX^[g
		}
		// LL :HiZioutFZZj  HL,LH:drive  HH:u[LioutFLLjɕύXKv 

}



//ADin ********************************************************************//
void InitAD()
{
	AD.ADCR.BYTE=0x00;	
	AD.ADCSR.BYTE=0x03;
	AD.ADCSR.BIT.ADST=1;
}

UINT AdRead(BYTE ch)
{
	BYTE temp;
	UDWORD x;
	
	AD.ADCSR.BIT.ADST=0;
	AD.ADCR.BYTE=0x00;
	AD.ADCSR.BYTE=0;
	
	if(ch>0x07)
		return 0;
		
	AD.ADCSR.BYTE=ch;
		
	AD.ADCSR.BIT.ADST=1;
	
	while (AD.ADCSR.BIT.ADF!=1);
	AD.ADCSR.BIT.ADF=0;	
	AD.ADCSR.BIT.ADST=0;
	
	
	x=0;
	switch(ch%4){
		case 0:
			x=AD.ADDRA;
			break;
		case 1:
			x=AD.ADDRB;
			break;
		case 2:
			x=AD.ADDRC;
			break;
		case 3:
			x=AD.ADDRD;
			break;
	}
	return (UINT)(x>>6);
}

//buzzer **********************************************************************//
BYTE BZR_PITCH;
BYTE BZR_VOL;

void BuzzerSet(BYTE pitch , BYTE vol){
	if(f_IREnable == 1)
		return;
	TV.TCRV1.BYTE=0x01;
	TV.TCRV0.BYTE=0x10;
	TV.TCSRV.BYTE=0x06;

	BZR_PITCH = pitch;
	BZR_VOL = vol;
	
	TV.TCRV0.BIT.CKS=0;
	TV.TCORA=(BYTE)((double)BZR_VOL*((double)BZR_PITCH/256.0));
	TV.TCORB=BZR_PITCH;
}

void BuzzerStart(){	
	if(f_IREnable == 1)
		return;
	TV.TCRV0.BIT.CKS=3;
}
BYTE isBuzzer(){
	if(f_IREnable == 1)
		return;
	if(TV.TCRV0.BIT.CKS == 0){
		return 0;
	}
	return 1;
}
void BuzzerStop(){
	if(f_IREnable == 1)
		return;
	TV.TCRV0.BIT.CKS=0;
}


//IR **********************************************************************//
void IREnable(BYTE en){
	f_IREnable = en;
}
void IRSet(){
	if(f_IREnable == 0)
		return;
		
	TV.TCRV0.BIT.CKS=0;
	TV.TCRV1.BYTE=0x01;		//NbN1/4JEg
	TV.TCRV0.BYTE=0x10;		//荞ݖARyABŃNAANbN1/4JEg
	TV.TCSRV.BYTE=0x06;		
	
	TV.TCRV0.BIT.CKS=0;
	TV.TCORA = 1; //f[eBݒ
	TV.TCORB = 2; //ݒ
}

void IRStart(){
	
	if(f_IREnable == 0)
		return;
	TV.TCRV0.BIT.CKS=3;
}

void IRStop(){
	
	if(f_IREnable == 0)
		return;
	TV.TCRV0.BIT.CKS=0;
}


//SCI ************************************************************************//


volatile BYTE sci_rxrb[SCI_RB_SIZE];
volatile BYTE rb_rd_num;
volatile BYTE rb_wr_num;

BYTE intsci3(){
	BYTE str[4],temp,next;
	
	if((SCI3.SSR.BYTE & 0x18)==0 && SCI3.SSR.BIT.RDRF == 1)
	{          
		next=(rb_wr_num+1)%SCI_RB_SIZE;
		
		if(rb_rd_num!=next){
			SCI3.SSR.BYTE &= 0x87;
			sci_rxrb[rb_wr_num] = SCI3.RDR;			//  f[^󂯎dataɕۑ 
			rb_wr_num=next;
			return 0;
		}
	}
	
	temp=SCI3.RDR;
	SCI3.SSR.BYTE &= 0x87;  
    return 1;
}


BYTE SciByteRx(BYTE *data)
{
	if(rb_rd_num!=rb_wr_num)	//Mobt@󂶂Ȃ
	{	
		*data=sci_rxrb[rb_rd_num];
		rb_rd_num=(rb_rd_num+1)%SCI_RB_SIZE;
		return 1;
	}
	else
		return 0;
}


void InitSci3(BYTE baudrate,BYTE parity ,BYTE stop)
{
	UINT dmy;
	BYTE smr = 0;
	
	switch(parity){
		case even:
			smr = 0x20;
		break;
		case odd:
			smr = 0x30;
		break;
		case non:
		default:
			smr = 0x00;
		break;
	}
	if(stop == 2){
		smr |= 0x08;
	}
	rb_rd_num = 0;
	rb_wr_num = 0;
	
	SCI3.SCR3.BYTE = 0;       //رٺ۰ڼ޽(SCȊM/Mݒ)
	SCI3.SMR.BYTE = smr;       //رӰڼ޽(SCI̒ʐM̫ϯĂ̐ݒ)
	SCI3.BRR = (BYTE)baudrate;	          //1bps
	
	for(dmy = 280;dmy > 0;dmy--); //Wait 1bit transfer time
	SCI3.SCR3.BYTE = 0x70;    //Enable Tx & Rx ,enable Rx interrupt
	IO.PMR1.BIT.TXD=1;
	SCI3.SSR.BYTE &= 0x80;   //Clear receive error flag

}

void SciByteTx(BYTE data)
{
	
	SCI3.SCR3.BIT.TE=1;
	while(SCI3.SSR.BIT.TDRE!=1);
	
	SCI3.TDR=data;
	
	while(SCI3.SSR.BIT.TEND!=1);
	SCI3.SCR3.BIT.TE=0;
}


void SciStrTx(BYTE *str,UINT dataleng)
{
	UINT i;
	SCI3.SCR3.BIT.TE=1;
	
	for(i=0;i<dataleng;i++)
		SciByteTx(str[i]);
}

//GAME_PAD ********************************************************//

//GAME_PAD
#define PS_SEL_raise	IO.PDR2.BIT.B3 = 1
#define PS_SEL_fall		IO.PDR2.BIT.B3 = 0
#define PS_CLK_raise	IO.PDR2.BIT.B4 = 1
#define PS_CLK_fall		IO.PDR2.BIT.B4 = 0
#define PS_CMD_raise	IO.PDR2.BIT.B0 = 1
#define PS_CMD_fall		IO.PDR2.BIT.B0 = 0
#define PS_DAT			IO.PDR7.BIT.B5
#define PS_CLK_BIT		IO.PDR2.BIT.B4

static const BYTE CMD_config_mode_enter[] =     {0x01,0x43,0x00,0x01, 0x00,0x00,0x00,0x00, 0x00};
static const BYTE CMD_config_mode_exit[] =      {0x01,0x43,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00};
static const BYTE CMD_config_mode_exit2[] =      {0x01,0x43,0x00,0x00, 0x5a,0x5a,0x5a,0x5a, 0x5a};
static const BYTE CMD_set_mode_and_lock[] =     {0x01,0x44,0x00,0x01, 0x03,0x00,0x00,0x00, 0x00};
static const BYTE CMD_query_model_and_mode[] =  {0x01,0x45,0x00,0x5a, 0x5a,0x5a,0x5a,0x5a, 0x5a};
static const BYTE CMD_vibration_enable[] =      {0x01,0x4d,0x00,0x00, 0x01,0xff,0xff,0xff, 0xff};
static const BYTE CMD_vibration_disnable[] =    {0x01,0x4d,0x00,0xff, 0xff,0xff,0xff,0xff, 0xff};
static const BYTE CMD_query_DS2_analog_mode[] = {0x01,0x41,0x00,0x5a, 0x5a,0x5a,0x5a,0x5a, 0x5a};
static const BYTE CMD_set_DS2_native_mode[] =   {0x01,0x4f,0x00,0xff, 0xff,0x03,0x00,0x00, 0x00};
static const BYTE CMD_read_data[] =             {0x01,0x42,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00}; 
static const BYTE CMD_read_data2[] =            {0x01,0x42,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 
											0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00};

BYTE PS_DATA[10];
//Mf[^
static BYTE PADRD[30];
#define muda 4

BYTE Ds2rw(const BYTE *cmd){
	
	BYTE TempCmd;
	BYTE i,j,data,clk_cnt = 1;
	

	data=0;
	PS_CLK_raise;
	PS_CMD_raise;
	TempCmd = *cmd;

  
  for(j=0;j<muda;j++);	//muda
  
  for(i=0;i<8;i++){
    if( (TempCmd & 0x01) == 0) /* CMDZbg */
        PS_CMD_fall;
    else
        PS_CMD_raise;

    TempCmd = TempCmd >> 1;
    PS_CLK_fall;
    
    for(j=0;j<muda;j++);	//muda
	
	if(PS_DAT!=0)
    	data+=clk_cnt;
	PS_CLK_raise;

    clk_cnt*=2;
    
  }
  PS_CMD_raise;
  return data;
}


//eR}hM
void Ds2Com(const unsigned char * cmd,unsigned char txLen){
  unsigned char i,j;
  PS_SEL_fall;
  
  for(j=0;j<muda;j++);	//muda
  
  for(i = 0; i < txLen;i++){
    for(j=0;j<muda*3;j++);	//muda
	PADRD[i]=Ds2rw(cmd+i);
  }
  
  PS_SEL_raise;
  
}


int PS_Set_AN()
{
	int a,i;
	const unsigned char temp[4]={0xFF,0xFF,0x03,0x5A};
	
	a=0;
	for(i=0;i<30;i++);
	Ds2Com(CMD_config_mode_enter,sizeof(CMD_config_mode_enter));	//RtBO[h
	for(i=0;i<30;i++);
	Ds2Com(CMD_config_mode_enter,sizeof(CMD_config_mode_enter));	//RtBO[h
	for(i=0;i<30;i++);

	Ds2Com(CMD_query_model_and_mode,sizeof(CMD_query_model_and_mode));
	for(i=0;i<30;i++);
	Ds2Com(CMD_query_model_and_mode,sizeof(CMD_query_model_and_mode));
	for(i=0;i<30;i++);

		Ds2Com(CMD_set_mode_and_lock,sizeof(CMD_set_mode_and_lock));
		for(i=0;i<100;i++);
		Ds2Com(CMD_set_mode_and_lock,sizeof(CMD_set_mode_and_lock));
		for(i=0;i<100;i++);
		Ds2Com(CMD_config_mode_exit,sizeof(CMD_config_mode_exit));
		for(i=0;i<100;i++);
		Ds2Com(CMD_config_mode_exit,sizeof(CMD_config_mode_exit));
		return 1;

	return 0;
}


void updatePAD()
{
	static unsigned char flag;
	int i;
	
	Ds2Com(CMD_read_data,sizeof(CMD_read_data));	
	
	if(PADRD[2] == 0x5a)
	{
		if(PADRD[1]==0x73){
			PS_DATA[0]=~PADRD[3];
			PS_DATA[1]=~PADRD[4];
			for(i=2;i<6;i++)
				PS_DATA[i]=PADRD[3+i];
		}
		else{
			PS_DATA[0]=~PADRD[3];
			PS_DATA[1]=~PADRD[4];
			for(i=2;i<6;i++)
				PS_DATA[i]=0x80;
			flag=PS_Set_AN();
		}
	}
	else
	{
		for(i=0;i<2;i++)
			PS_DATA[i]=0;
		for(i=2;i<6;i++)
			PS_DATA[i]=0x80;
	}
}

BYTE getPAD(BYTE num){
	if(num <= PAD_AN_LY && num>= 0)
		return PS_DATA[num];
	else
		return 0;
}
//encoder**********************************************************//
int enc_L,enc_R;
 
const signed char enctbl[16] = {
  00, //* 00 -> 00 
  +1, //* 00 -> 01 
  -1, //* 00 -> 10 
  00, //* 00 -> 11 
  -1, //* 01 -> 00 
  00, //* 01 -> 01 
  00, //* 01 -> 10 
  +1, //* 01 -> 11 
  +1, //* 10 -> 00 
  00, //* 10 -> 01 
  00, //* 10 -> 10 
  -1, //* 10 -> 11 
  00, //* 11 -> 00 
  -1, //* 11 -> 01 
  +1, //* 11 -> 10 
  00, //* 11 -> 11 
};

void intencoder(){

  static unsigned char L = 0;
  static unsigned char old_L = 0;
  static unsigned char R = 0;
  static unsigned char old_R = 0;
 
 	unsigned char temp1,temp2;
	temp1 = IWPR.BYTE;
	temp2 = IRR1.BYTE;

	L |= (temp1 & 0x03);
	R |= ((temp1 >>2 ) & 0x03);
	L &= ~(temp2 & 0x03);
	R &= ~((temp2 >> 2 ) & 0x03);
	
	enc_L -= enctbl[(old_L<<2) | L];
	old_L = L;
	enc_R -= enctbl[(old_R<<2) | R];
	old_R = R;
	
	IWPR.BYTE = 0x00;
	IRR1.BYTE = 0x00;
	LED(enc_L + enc_R);
	
}

void ClearZ(){
	enc_L = 0;
	enc_R = 0;
}

#define ADC_SCK IO.PDR2.BIT.B4
#define ADC_SEL IO.PDR1.BIT.B2
#define ADC_DAT IO.PDR7.BIT.B5

int GetGyro()
{
	 signed short gyro_dt = 0;
      unsigned char i;
      ADC_SCK = 1;
      ADC_SEL = 0;
      for(i=0; i<16; i++) {
		ADC_SCK = 0;
		gyro_dt<<=1;
		ADC_SCK = 1;
		gyro_dt |= ADC_DAT;
      }
      ADC_SEL = 1;

      if(gyro_dt & ((int)1<<12)) gyro_dt |= (int)0xf000;
      else                  gyro_dt &= (int)0x0fff;
	  return gyro_dt;
}


BYTE MAINCYCLE;
//other ***********************************************************//
void Init(BYTE MainCycle)
{
	MAINCYCLE = MainCycle;
	IENR1.BIT.IENWP = 0;
	//XCb`p55 input & pull up
	IO.PMR5.BYTE= 0x0F;	
	IO.PCR5=0x00;
	IWPR.BYTE = 0x00;
	IO.PUCR5.BYTE=0xF0;
	IEGR2.BIT.WPEG0 = 0;
	IEGR2.BIT.WPEG1 = 0;
	IEGR2.BIT.WPEG2 = 0;
	IEGR2.BIT.WPEG3 = 0;
	IENR1.BIT.IENWP = 1;
	
	
	
	//LCD+PS
	IO.PMR1.BYTE=0xF0;
	IO.PCR1=0x0F;
	IO.PDR1.BYTE=0x00;
	
	//encoder R
	IEGR1.BIT.IEG3 = 1;	
	IEGR1.BIT.IEG2 = 1;	
	IEGR1.BIT.IEG1 = 1;	
	IEGR1.BIT.IEG0 = 1;		
	
	IENR1.BYTE |= 0x0F;
	
	
	//PS_CMD0,SEL3,CLK4
	IO.PCR2=0xFF;
	IO.PDR2.BIT.B3 = 1;
	IO.PDR2.BIT.B4 = 1;
	IO.PDR2.BIT.B0 = 1;
	
	//IO{EEP0124+BUZZER6+PS_DAT5}
	IO.PCR7=0xDF;
	
	IO.PDR7.BIT.B6=0;
	IO.PDR7.BIT.B4=1;
	
	ADC_SEL = 1;
	
	//WD->off
	WDT.TCSRWD.BYTE=0x92;	
	WDT.TCSRWD.BYTE=0x92;
	
	WDT.TCSRWD.BIT.B4WI = 0;
	WDT.TCSRWD.BIT.TCSRWE=1;

	WDT.TCSRWD.BIT.B2WI=0;
	WDT.TCSRWD.BIT.WDON=0;
	
	WDT.TMWD.BYTE=0xFF;
	WDT.TCSRWD.BIT.B6WI = 1;
	WDT.TCSRWD.BIT.TCWE = 1;
	WDT.TCWD=0x00;
	
	//motor output logic
	IO.PCR3=0xFF;
	IO.PDR3.BYTE=0x00;
	
	//motor PWM & SV PWM
	IO.PCR6=0xFF;
	IO.PDR6.BYTE=0xF0;
	
	//TB1 main
	TB1.TMB1.BYTE=0xF9;		//I[g[hA/2048
	//TB1.TCB1=192;//136;			//256-120
	TB1.TCB1 = (BYTE)(256.0-((14745600.0/2048.0)/(double)MAINCYCLE));
	
	IO.PCR8 = 0xFF;
	IO.PDR8.BYTE = 0x00;
	
	InitMtrPwm();
	InitAD();
}

BYTE getMainCycle(){
	return MAINCYCLE;
}

BYTE getSW()		//XCb`ǂݍ
{
	BYTE x=0;

	if(IO.PDR5.BIT.B5==0)
		x+=1;
	return x;
}

//b0 LED1 ,b1 LED2
void LED(BYTE LedOn){
	
	if(LedOn == 5)
		IO.PDR1.BIT.B1 = ~IO.PDR1.BIT.B1;
	else
		IO.PDR1.BIT.B1 = ~LedOn&0x01;
}

void Wait(int msec)
{
	double waittime,waitcnt = 0.0;
	waittime = 1000.0/(double)MAINCYCLE;
	do{
		Sync();
		waitcnt += waittime;
	}while(waitcnt < (double)msec);
}

UINT Sync()
{
	UINT aa = 0;
	WDT.TCWD=0x00;
	while(IRR2.BIT.IRRTB1!=1)
		aa++;
	IRR2.BIT.IRRTB1=0;
	return aa;
}

